/*
	Copyright (C) 2005 dxp

	This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "includes.h"

/* ----------------------------------- Error () ---------------------------- */
void
Error (const int quit, const int errcode, const char *msg)
{
	fprintf (stderr, "%i\t%s\n", errcode, msg);

	if (quit)
		exit (errcode);
}
/* ----------------------------------- Usage () ---------------------------- */
void
Usage (void)
{
	unsigned long int	sec, micro;
	int			rv;
	

	rv = getrusage (RUSAGE_SELF, &usage);
	if (rv == -1)
		Error (1, errno, "getrusage()");

	sec = usage.ru_utime.tv_sec + usage.ru_stime.tv_sec;
	micro = usage.ru_utime.tv_usec + usage.ru_stime.tv_usec;
	
	if (micro > 1000000)
		{
			sec++;
			micro -= 1000000;
		}
	
	printf ("Elapsed Time:  \t%li.%03lis\n", sec, micro / 1000);
}
/* ----------------------------------- found () ---------------------------- */
void
found (const char *word, const char *chash, const char *ihash, const int mode)
{
/*
	long int	sec, mili;
	int		rv;
*/

	printf ("\n***CRACKED ");
	switch (mode)
		{
			case 1:	printf ("MD5");	break;
			case 2:	printf ("SHA1");	break;
			default:	printf ("Unknown");	break;
		}
	printf (" HASH***\n");

	printf ("String:        \t%s\n", word);
	printf ("Computed HASH: \t%s\n", chash);
	printf ("Input HASH:    \t%s\n", ihash);
	Usage ();
	
	printf("Hash calls: %u\nTotal characters: %i\n", counter, counter2);
	
	exit (EXIT_SUCCESS);
}
/* ----------------------------------- hash2digest () ---------------------- */
unsigned char *
hash2digest (const char *hash)
{
	static unsigned char	digest[21];
	unsigned int		len = strlen (hash); 
	unsigned int		i, di = 0;
	unsigned char		x;

	for (i = 0; i < len; i += 2) {
		x = 16 * hex2int (hash[i]);
		x = x + hex2int (hash[i + 1]);
		digest[di++] = x;
	}
	digest[di] = '\0';
	pd_len = di - 1;
	
	return digest;
}
/* ----------------------------------- hex2int () ---------------------- */
unsigned char
hex2int (const char hex)
{
	static unsigned char	binary;
	unsigned char		uppercase;

	uppercase = toupper (hex);
	if ( uppercase > 47 && uppercase < 58)
		binary = uppercase - 48;
	else
		binary = uppercase - 55;

	return binary;
}	
/* ----------------------------------- digestcmp () ---------------------- */
uint32_t
digestcmp (const unsigned char *digest)
{
	unsigned int	i;

	// Compare given digest against the computed, check in blocks of 4 bytes.
	for (i = 0; i < pd_len; i += 4)
		if ( *(unsigned int *) (password_digest + i) != *(unsigned int *) (digest + i) )
			return 1;

	return 0;
}
/* ----------------------------------- digest2hash () ---------------------- */
char *
digest2hash (const unsigned char *digest, const int mode)
{
	int	j;
	static char		output[41];

/*
	for (i = 0; i < x; i++)
		{
			j = digest[i];
			output[i << 1] = fasthex[ (j >> 4) & 0x0f ];
			output[ (i << 1) + 1 ] = fasthex[j & 0x0f];
		}
	
	output[x << 1] = 0;
*/
/*
	We'll use a macro to convert with constant index,
	which will be faster then variable incrementation.
*/
	switch (mode)
		{
			case 1:
				convert (0);
				convert (1);
				convert (2);
				convert (3);
				convert (4);
				convert (5);
				convert (6);
				convert (7);
				convert (8);
				convert (9);
				convert (10);
				convert (11);
				convert (12);
				convert (13);
				convert (14);
				convert (15);
				output[32] = 0;
				break;

			case 2:
				convert (0);
				convert (1);
				convert (2);
				convert (3);
				convert (4);
				convert (5);
				convert (6);
				convert (7);
				convert (8);
				convert (9);
				convert (10);
				convert (11);
				convert (12);
				convert (13);
				convert (14);
				convert (15);
				convert (16);
				convert (17);
				convert (18);
				convert (19);
				output[40] = 0;
				break;
		}

	return output;
}

/* ----------------------------------- brute2 () ---------------------- */
/*
	Main for loop which calls the recursive function whil advancing
	characters in the word arrary.
*/
void
brute2 (void)
{
	uint32_t	pos, x;

	x = wlen;
	memset(word_rf, '\0', 128);		
	for (pos = 0; pos < wlen; pos++)
		word_rf[pos] = alphabet[0];

	for (pos = wlen; pos < 128; pos++)	{
		if (pos < wlen)
			printf("Trying Word Length: %i\t\t", x++);
		else
			printf ("Trying Word Length: %i\t\t", pos);
		rf(pos);
		wlen++;
		Usage();
	}	
}
/* ----------------------------------- rf () ---------------------- */
/*
	Recursive function which call the calculation() for every
	character position within a word or itself when every
	character in a position has been tried and we need to advance.
*/
void
rf (const int pos)
{
	uint32_t	i, j = 0, alphabet_len;
	
	alphabet_len = strlen(alphabet);
	
	if (pos == 1) {
		for (i = wlen - 1; j < alphabet_len; j++) {
			word_rf[i] = alphabet[j];
			counter++;
			word_rf_len = strlen(word_rf);
			counter2 += word_rf_len;
			calculation(); // brute force
		}
	}
	else {
		for (i = wlen - pos; j < alphabet_len; j++) {
			word_rf[i] = alphabet[j];
			rf(pos - 1);
		}
	}	
}
/* ----------------------------------- get_index () ---------------------- */
/*
unsigned int
get_index (const char ch)
{
	unsigned int	i = 0;

	while (1) {
		if(ch == alphabet[i++])
			break;
	}
	return i - 1;
}
*/
